# Generated by Django 5.2.1 on 2025-06-05 09:37

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='DJBackUpBase',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('note', models.TextField(blank=True, null=True)),
                ('unit', models.CharField(choices=[('minutes', 'Minutes'), ('hours', 'Hours'), ('days', 'Days'), ('weeks', 'Weeks')], max_length=10)),
                ('interval', models.SmallIntegerField()),
                ('last_run', models.DateTimeField(auto_now=True)),
                ('repeats', models.SmallIntegerField(default=0)),
                ('count_run', models.PositiveIntegerField(default=0)),
                ('has_temp', models.BooleanField(default=True)),
                ('has_running_task', models.BooleanField(default=False)),
            ],
            options={
                'ordering': ('-id',),
            },
        ),
        migrations.CreateModel(
            name='DJBackupLog',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('level', models.CharField(max_length=10)),
                ('msg', models.TextField(blank=True, null=True)),
                ('exc', models.TextField(blank=True, null=True)),
                ('is_seen', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
            ],
            options={
                'ordering': ('created_at',),
            },
        ),
        migrations.CreateModel(
            name='DJBackupLogLevel',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('level_n', models.IntegerField(default=20)),
                ('email', models.EmailField(max_length=254)),
                ('is_active', models.BooleanField(default=True)),
            ],
        ),
        migrations.CreateModel(
            name='DJBackUpStorageResult',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.CharField(choices=[('successful', 'Successful'), ('unsuccessful', 'Unsuccessful')], max_length=12)),
                ('backup_name', models.TextField()),
                ('out', models.TextField(blank=True, null=True)),
                ('temp_location', models.TextField(blank=True, null=True)),
                ('size', models.PositiveIntegerField()),
                ('time_taken', models.FloatField(default=0)),
                ('description', models.TextField(blank=True, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
            ],
            options={
                'ordering': ('-id',),
            },
        ),
        migrations.CreateModel(
            name='DJFile',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200)),
                ('dir', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='DJStorage',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=20)),
                ('display_name', models.CharField(max_length=20)),
                ('checked', models.BooleanField(default=False)),
            ],
        ),
        migrations.CreateModel(
            name='TaskSchedule',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('task_id', models.CharField(max_length=300)),
                ('func', models.TextField()),
                ('seconds', models.PositiveBigIntegerField()),
                ('repeats', models.IntegerField(default=-1)),
                ('count_run', models.IntegerField(default=0, editable=False)),
                ('kwargs', models.JSONField(blank=True, null=True)),
                ('args', models.TextField(blank=True, null=True)),
                ('last_run', models.DateTimeField(blank=True, default=None, null=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
            ],
        ),
        migrations.CreateModel(
            name='DJDataBaseBackUp',
            fields=[
                ('djbackupbase_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='dj_backup.djbackupbase')),
                ('database', models.CharField(max_length=40)),
                ('database_type', models.CharField(max_length=40)),
                ('additional_args', models.TextField(blank=True, null=True)),
            ],
            bases=('dj_backup.djbackupbase',),
        ),
        migrations.AddField(
            model_name='djbackupbase',
            name='results',
            field=models.ManyToManyField(blank=True, to='dj_backup.djbackupstorageresult'),
        ),
        migrations.AddField(
            model_name='djbackupstorageresult',
            name='storage',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='dj_backup.djstorage'),
        ),
        migrations.AddField(
            model_name='djbackupbase',
            name='storages',
            field=models.ManyToManyField(blank=True, to='dj_backup.djstorage'),
        ),
        migrations.AddField(
            model_name='djbackupbase',
            name='schedule_task',
            field=models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to='dj_backup.taskschedule'),
        ),
        migrations.CreateModel(
            name='DJFileBackUp',
            fields=[
                ('djbackupbase_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='dj_backup.djbackupbase')),
                ('files', models.ManyToManyField(to='dj_backup.djfile')),
            ],
            bases=('dj_backup.djbackupbase',),
        ),
    ]
